module SidekiqRepeatingJobs

  class Config

    DEFAULT_EXPIRATION_SECONDS=30*60
    DEFAULT_REPEAT_SECONDS=60

    class << self

      def active?(worker_class)
        worker_class.get_sidekiq_options['repeat'].present?
      end

      def job_name(worker_class)
        worker_class.get_sidekiq_options['repeating_job_name'] || worker_class.name.demodulize.underscore
      end

      def repeat_interval(worker_class)
        (r = worker_class.get_sidekiq_options['repeat']).is_a?(Fixnum) ? r : DEFAULT_REPEAT_SECONDS
      end

      def expiration_interval(worker_class)
        self.repeat_interval(worker_class) + (worker_class.get_sidekiq_options['repeating_job_expiration'] || DEFAULT_EXPIRATION_SECONDS)
      end

    end

  end

end