module SidekiqRepeatingJobs
  module Middleware
    module Server
      class RepeatingJobs
        include SidekiqRepeatingJobs::Middleware::Helpers

        def log_name
          "RepeatingJobServer"
        end

        def call(*args)
          worker_class=eval(args[1]['class'])
          if SidekiqRepeatingJobs::Config.active?(worker_class)
            arguments=args[1]['args'].slice!(-1)
            if valid_arguments?(worker_class, arguments)
              begin
                yield
              ensure
                worker_class.perform_in(SidekiqRepeatingJobs::Config.repeat_interval(worker_class), *args[1]['args'], arguments)
                self.log_message(arguments, "scheduled in #{SidekiqRepeatingJobs::Config.repeat_interval(worker_class)} seconds")
              end
            end
          else
            yield
          end
        end
      end
    end
  end
end
